diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_oper.c PleXusIRCd-1.17a/modules/m_oper.c
--- ircd-hybrid-7.0/modules/m_oper.c	Wed Nov  6 16:17:59 2002
+++ PleXusIRCd-1.17a/modules/m_oper.c	Mon Aug 18 23:17:54 2003
@@ -146,7 +146,8 @@
     }
 
     oper_up(source_p, aconf);
-      
+    strncpy(source_p->vhost, STAFF_HOSTMASK, HOSTLEN);
+    sendto_server(NULL, source_p, NULL, 0, 0, LL_ICLIENT, ":%s SETHOST %s :%s", me.name, source_p->name, source_p->vhost);
     ilog(L_TRACE, "OPER %s by %s!%s@%s",
 	 name, source_p->name, source_p->username, source_p->host);
     log_oper(source_p, name);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_sethost.c PleXusIRCd-1.17a/modules/m_sethost.c
--- ircd-hybrid-7.0/modules/m_sethost.c	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_sethost.c	Sun Sep  7 09:45:34 2003
@@ -0,0 +1,135 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, m_sethost.c
+ *   Copyright (C) 2003 PleXusIRCd Development Team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_sethost.c,v 1.5 2002/10/16 05:33:22 fishwaldo Exp $
+ */
+
+/* List of ircd includes from ../include/ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+
+/* Declare the void's initially up here, as modules dont have an
+ * include file, we will normally have client_p, source_p, parc
+ * and parv[] where:
+ *
+ * client_p == client issuing command
+ * source_p == where the command came from
+ * parc     == the number of parameters
+ * parv     == an array of the parameters
+ */
+static void ms_sethost(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+/* Show the commands this module can handle in a msgtab
+ * and give the msgtab a name, here its test_msgtab
+ */
+struct Message sethost_msgtab = {
+  "SETHOST", 0, 0, 3, 3, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_sethost, m_ignore}
+};
+
+/* Thats the msgtab finished */
+
+#ifndef STATIC_MODULES
+/* Here we tell it what to do when the module is loaded */
+void
+_modinit(void)
+{
+  /* This will add the commands in test_msgtab (which is above) */
+  mod_add_cmd(&sethost_msgtab);
+}
+
+/* here we tell it what to do when the module is unloaded */
+void
+_moddeinit(void)
+{
+  /* This will remove the commands in test_msgtab (which is above) */
+  mod_del_cmd(&sethost_msgtab);
+}
+
+/* When we last modified the file (shown in /modlist), this is usually:
+ */
+const char *_version = "$Revision: 1.5 $";
+#endif
+
+/*
+ * ms_sethost
+ *	Changes the Targets Virtual Hostname, and also sets +h if its not set already on the target
+ *      parv[0] = sender prefix
+ *      parv[1] = target
+ *      parv[2] = new hostname
+ */
+static void ms_sethost(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+	struct Client *target_p;
+
+	sendto_one(source_p, "NOTICE %s :*** Src: (%s), Target: (%s), Mask: (%s)", me.name, source_p->name, parv[1], parv[2]);	
+	target_p = find_person(parv[1]);
+	/* first find the target that we want to change */
+	if (target_p != NULL) {
+		sendto_one(source_p, "NOTICE %s :*** Src: (%s), Target: (%s), Mask: (%s)", me.name, source_p->name, parv[1], parv[2]);		
+		if (IsServer(source_p)) {
+			
+			/* client is changing his own hostname */
+			
+			/* check its not a client on my server, because this is a error then */
+			/* use svshost instead. */
+			if (MyClient(target_p)) {
+				return;
+			}
+
+			SetHidden(target_p);		
+			strncpy(target_p->vhost, parv[2], HOSTLEN);
+		
+			/* send it to the rest of the net */
+			sendto_server(source_p, source_p, NULL, 0, 0, LL_ICLIENT, ":%s SETHOST %s :%s", source_p->name, target_p->name, target_p->vhost);
+	
+			return;
+		
+		} else if (IsClient(source_p)) {
+			/* can't change someone else's host. (services use svshost) */
+			sendto_one(source_p, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+			return;
+		}
+	} else {
+		/* debug */
+		sendto_one(source_p, "NOTICE %s :*** Src: (%s), Target: (%s), Mask: (%s)", me.name, source_p->name, parv[1], parv[2]);
+		/* we couldn't find the target, jsut return */
+		return;
+	}
+}    
+	  
+
+
+
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_stats.c PleXusIRCd-1.17a/modules/m_stats.c
--- ircd-hybrid-7.0/modules/m_stats.c	Tue May  6 01:32:16 2003
+++ PleXusIRCd-1.17a/modules/m_stats.c	Fri Nov 28 05:55:15 2003
@@ -379,9 +379,9 @@
 }
 
 /* stats_pending_glines()
- *
- * input	- client pointer
- * output	- none
+ *   
+ * input        - client pointer
+ * output       - none
  * side effects - client is shown list of pending glines
  */
 static void
@@ -391,53 +391,53 @@
   struct gline_pending *glp_ptr;
   char timebuffer[MAX_DATE_STRING];
   struct tm *tmptr;
-
+ 
   if(!ConfigFileEntry.glines)
   {
     sendto_one(source_p, ":%s NOTICE %s :This server does not support G-Lines",
-               me.name, source_p->name); 
+               me.name, source_p->name);
     return;
   }
-
+ 
   if (dlink_list_length(&pending_glines) > 0)
     sendto_one(source_p, ":%s NOTICE %s :Pending G-lines",
-	       me.name, source_p->name);
-
+               me.name, source_p->name);
+ 
   DLINK_FOREACH(pending_node, pending_glines.head)
   {
     glp_ptr = pending_node->data;
-      
+
     tmptr = localtime(&glp_ptr->time_request1);
     strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
-
+  
     sendto_one(source_p,
-	       ":%s NOTICE %s :1) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-	       me.name, source_p->name, glp_ptr->oper_nick1,
-	       glp_ptr->oper_user1, glp_ptr->oper_host1,
-	       glp_ptr->oper_server1, timebuffer,
-	       glp_ptr->user, glp_ptr->host, glp_ptr->reason1);
-
-    if(glp_ptr->oper_nick2[0] != '\0')
+               ":%s NOTICE %s :1) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
+               me.name, source_p->name, glp_ptr->oper_nick1,
+               glp_ptr->oper_user1, glp_ptr->oper_host1,
+               glp_ptr->oper_server1, timebuffer,
+               glp_ptr->user, glp_ptr->host, glp_ptr->reason1);
+    
+    if(glp_ptr->oper_nick2[0] != '\0')  
     {
       tmptr = localtime(&glp_ptr->time_request2);
       strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
       sendto_one(source_p,
       ":%s NOTICE %s :2) %s!%s@%s on %s requested gline at %s for %s@%s [%s]",
-		 me.name, source_p->name, glp_ptr->oper_nick2,
-		 glp_ptr->oper_user2, glp_ptr->oper_host2,
-		 glp_ptr->oper_server2, timebuffer,
-		 glp_ptr->user, glp_ptr->host, glp_ptr->reason2);
+                 me.name, source_p->name, glp_ptr->oper_nick2,
+                 glp_ptr->oper_user2, glp_ptr->oper_host2,
+                 glp_ptr->oper_server2, timebuffer,
+                 glp_ptr->user, glp_ptr->host, glp_ptr->reason2);
     }
   }
-
+  
   sendto_one(source_p, ":%s NOTICE %s :End of Pending G-lines",
-	     me.name, source_p->name);
+             me.name, source_p->name);
 }
 
 /* stats_glines()
- *
- * input	- client pointer
- * output	- none
+ * 
+ * input        - client pointer
+ * output       - none
  * side effects - client is shown list of glines
  */
 static void
@@ -452,14 +452,14 @@
   if(!ConfigFileEntry.glines)
   {
     sendto_one(source_p, ":%s NOTICE %s :This server does not support G-Lines",
-               me.name, source_p->name); 
+               me.name, source_p->name);
     return;
   }
-
+               
   DLINK_FOREACH(gline_node, glines.head)
   {
     kill_ptr = gline_node->data;
-
+    
     if(kill_ptr->host)
       host = kill_ptr->host;
     else
@@ -469,18 +469,17 @@
       name = kill_ptr->name;
     else
       name = "*";
-
+     
     if(kill_ptr->passwd)
       reason = kill_ptr->passwd;
     else
       reason = "No Reason";
-    
+ 
     sendto_one(source_p, form_str(RPL_STATSKLINE), me.name,
-	       source_p->name, 'G', host, name, reason);
+               source_p->name, 'G', host, name, reason);
   }
 }
 
-
 static void
 stats_hubleaf(struct Client *source_p)
 {
@@ -665,7 +664,7 @@
                  me.name, RPL_STATSDEBUG, source_p->name,
                  IsOperAdmin(target_p) ? 'A' : 'O',
 		 oper_privs_as_string(target_p, aconf->port),
-		 target_p->name, target_p->username, target_p->host,
+		 target_p->name, target_p->username, target_p->vhost,
 		 (int)(CurrentTime - target_p->user->last));
     }
     else
@@ -673,7 +672,7 @@
       sendto_one(source_p, ":%s %d %s p :[%c] %s (%s@%s) Idle: %d",
                  me.name, RPL_STATSDEBUG, source_p->name,
                  IsOperAdmin(target_p) ? 'A' : 'O',
-		 target_p->name, target_p->username, target_p->host,
+		 target_p->name, target_p->username, target_p->vhost,
 		 (int)(CurrentTime - target_p->user->last));
     }
   }
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_svsalias.c PleXusIRCd-1.17a/modules/m_svsalias.c
--- ircd-hybrid-7.0/modules/m_svsalias.c	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_svsalias.c	Sun Sep  7 09:46:18 2003
@@ -0,0 +1,369 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, m_svscmds.c
+ *   Copyright (C) 2003 PleXusIRCd Development Team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svscmds.c,v 1.8 2002/09/25 07:43:28 fishwaldo Exp $
+ */
+
+/* List of ircd includes from ../include/ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "hash.h"
+#include "whowas.h"
+
+/* Declare the void's initially up here, as modules dont have an
+ * include file, we will normally have client_p, source_p, parc
+ * and parv[] where:
+ *
+ * client_p == client issuing command
+ * source_p == where the command came from
+ * parc     == the number of parameters
+ * parv     == an array of the parameters
+ */
+static void ms_ns(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+static void ms_cs(struct Client *client_p, struct Client *source_p,
+		    int parc, char *parv[]);
+
+static void ms_os(struct Client *client_p, struct Client *source_p,
+		    int parc, char *parv[]);
+
+static void ms_ms(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+static void ms_bs(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+static void ms_hs(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+static void ms_ident(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+static void ms_vhost(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+#define MAXLINE  512
+
+/* Show the commands this module can handle in a msgtab
+ * and give the msgtab a name, here its test_msgtab
+ */
+struct Message ns_msgtab = {
+  "NS", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_ns, m_error, ms_ns}
+};
+struct Message nickserv_msgtab = {
+  "NICKSERV", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_ns, m_error, ms_ns}
+};
+struct Message cs_msgtab = {
+  "CS", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_cs, m_error, ms_cs}
+};
+struct Message chanserv_msgtab = {
+  "CHANSERV", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_cs, m_error, ms_cs}
+};
+struct Message os_msgtab = {
+  "OS", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_os, m_error, ms_os}
+};
+struct Message operserv_msgtab = {
+  "OPERSERV", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_os, m_error, ms_os}
+};
+struct Message ms_msgtab = {
+  "MS", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_ms, m_error, ms_ms}
+};
+struct Message memoserv_msgtab = {
+  "MEMOSERV", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_ms, m_error, ms_ms}
+};
+struct Message bs_msgtab = {
+  "BS", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_bs, m_error, ms_bs}
+};
+struct Message botserv_msgtab = {
+  "BOTSERV", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_bs, m_error, ms_bs}
+};
+struct Message hs_msgtab = {
+  "HS", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_hs, m_error, ms_hs}
+};
+struct Message helpserv_msgtab = {
+  "HELPSERV", 0, 0, 1, 0, MFLG_SLOW, 0,
+  {m_error, ms_hs, m_error, ms_hs}
+}; 
+struct Message ident_msgtab = {
+  "IDENTIFY", 0, 0, 1, 2, MFLG_SLOW, 0,
+  {m_error, ms_ident, m_error, ms_ident}
+}; 
+struct Message vhost_msgtab = {
+  "VHOST", 0, 0, 1, 3, MFLG_SLOW, 0,
+  {m_error, ms_vhost, m_error, ms_vhost}
+}; 
+
+/* Thats the msgtab finished */
+
+#ifndef STATIC_MODULES
+/* Here we tell it what to do when the module is loaded */
+void
+_modinit(void)
+{
+  /* This will add the commands in test_msgtab (which is above) */
+  mod_add_cmd(&ns_msgtab);
+  mod_add_cmd(&nickserv_msgtab);
+  mod_add_cmd(&cs_msgtab);
+  mod_add_cmd(&chanserv_msgtab); 
+  mod_add_cmd(&os_msgtab);
+  mod_add_cmd(&operserv_msgtab); 
+  mod_add_cmd(&ms_msgtab);
+  mod_add_cmd(&memoserv_msgtab); 
+  mod_add_cmd(&bs_msgtab);
+  mod_add_cmd(&botserv_msgtab); 
+  mod_add_cmd(&hs_msgtab);
+  mod_add_cmd(&helpserv_msgtab); 
+  mod_add_cmd(&ident_msgtab);
+  mod_add_cmd(&vhost_msgtab);
+}
+
+/* here we tell it what to do when the module is unloaded */
+void
+_moddeinit(void)
+{
+  /* This will remove the commands in test_msgtab (which is above) */
+  mod_del_cmd(&ns_msgtab);
+  mod_del_cmd(&nickserv_msgtab);
+  mod_del_cmd(&cs_msgtab);
+  mod_del_cmd(&chanserv_msgtab);
+  mod_del_cmd(&os_msgtab);
+  mod_del_cmd(&operserv_msgtab);
+  mod_del_cmd(&ms_msgtab);
+  mod_del_cmd(&memoserv_msgtab);
+  mod_del_cmd(&bs_msgtab);
+  mod_del_cmd(&botserv_msgtab);
+  mod_del_cmd(&hs_msgtab);
+  mod_del_cmd(&helpserv_msgtab);
+  mod_del_cmd(&ident_msgtab);
+  mod_del_cmd(&vhost_msgtab);
+}
+
+/* When we last modified the file (shown in /modlist), this is usually:
+ */
+const char *_version = "$Revision: 1.2 $";
+#endif
+
+char *getString(int parc, char *parv[])
+{
+  char *final;
+  char temp[MAXLINE];
+  int ii = 0;
+
+  final = MyMalloc(sizeof(char));
+  *final = '\0';
+
+  while (ii < parc)
+  {
+    ircsprintf(temp, "%s%s", parv[ii], ((ii + 1) >= parc) ? "" : " ");
+    final = MyRealloc(final,  strlen(final) + strlen(temp) +
+        sizeof(char));
+    strcat(final, temp);
+    ++ii;
+  }
+
+  return (final);
+} /* getString() */
+
+static void ms_ident(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+	struct Client *target_p;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(SERVICES)) {
+		sendto_one(target_p, ":%s PRIVMSG %s@%s :IDENTIFY %s", parv[0], "NICKSERV", SERVICES, parv[1]);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+}
+
+static void ms_vhost(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+	struct Client *target_p;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(HOSTSERV)) {
+		sendto_one(target_p, ":%s PRIVMSG %s :VHOST %s %s", parv[0], "HOSTSERV", parv[1], parv[2]);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+}
+
+
+static void ms_ns(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+	struct Client *target_p;
+	char *servst;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(SERVICES)) {
+		servst = getString(parc -1, parv +1);
+
+		sendto_one(target_p, ":%s PRIVMSG %s@%s :%s", parv[0], "NICKSERV", SERVICES, servst);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+}
+
+static void ms_cs(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+      struct Client *target_p;
+	char *servst;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(SERVICES)) {
+		servst = getString(parc -1, parv +1);
+
+		sendto_one(target_p, ":%s PRIVMSG %s@%s :%s", parv[0], "CHANSERV", SERVICES, servst);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+
+}
+
+static void ms_os(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+      struct Client *target_p;
+	char *servst;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(SERVICES)) {
+		servst = getString(parc -1, parv +1);
+
+		sendto_one(target_p, ":%s PRIVMSG %s@%s :%s", parv[0], "OPERSERV", SERVICES, servst);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+
+}
+
+static void ms_ms(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+      struct Client *target_p;
+	char *servst;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(SERVICES)) {
+		servst = getString(parc -1, parv +1);
+
+		sendto_one(target_p, ":%s PRIVMSG %s@%s :%s", parv[0], "MEMOSERV", SERVICES, servst);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+
+}
+
+static void ms_bs(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+      struct Client *target_p;
+	char *servst;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(SERVICES)) {
+		servst = getString(parc -1, parv +1);
+
+		sendto_one(target_p, ":%s PRIVMSG %s@%s :%s", parv[0], "BOTSERV", SERVICES, servst);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+
+}
+
+static void ms_hs(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+      struct Client *target_p;
+	char *servst;
+
+	if (parc < 2) { 
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "MODE");
+        }
+	
+	if (target_p = find_server(SERVICES)) {
+		servst = getString(parc -1, parv +1);
+
+		sendto_one(target_p, ":%s PRIVMSG %s@%s :%s", parv[0], "HELPSERV", SERVICES, servst);
+        } else {
+		sendto_one(source_p, ":%s 425 %s :Services are currently down, if you have any questions please join #help.", me.name, parv[0]);
+	}
+	return;
+
+}
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_svscmds.c PleXusIRCd-1.17a/modules/m_svscmds.c
--- ircd-hybrid-7.0/modules/m_svscmds.c	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_svscmds.c	Tue Sep 30 23:46:15 2003
@@ -0,0 +1,292 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, m_svscmds.c
+ *   Copyright (C) 2003 PleXusIRCd Development Team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_svscmds.c,v 1.8 2002/09/25 07:43:28 fishwaldo Exp $
+ */
+
+/* List of ircd includes from ../include/ */
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "common.h"     /* FALSE bleah */
+#include "ircd.h"
+#include "irc_string.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "s_user.h"
+#include "send.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "hash.h"
+#include "whowas.h"
+
+/* Declare the void's initially up here, as modules dont have an
+ * include file, we will normally have client_p, source_p, parc
+ * and parv[] where:
+ *
+ * client_p == client issuing command
+ * source_p == where the command came from
+ * parc     == the number of parameters
+ * parv     == an array of the parameters
+ */
+static void ms_svshost(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+
+static void ms_svsnick(struct Client *client_p, struct Client *source_p,
+		    int parc, char *parv[]);
+
+static void ms_svsid(struct Client *client_p, struct Client *source_p,
+		    int parc, char *parv[]);
+
+static void ms_svsmode(struct Client *client_p, struct Client *source_p,
+			 int parc, char *parv[]);
+
+
+
+static int clean_nick_name(char *);
+
+/* Show the commands this module can handle in a msgtab
+ * and give the msgtab a name, here its test_msgtab
+ */
+struct Message svshost_msgtab = {
+  "SVSHOST", 0, 0, 3, 3, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svshost, m_ignore}
+};
+
+struct Message svsnick_msgtab = {
+  "SVSNICK", 0, 0, 3, 3, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svsnick, m_ignore}
+};
+
+struct Message svsid_msgtab = {
+  "SVSID", 0, 0, 3, 3, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svsid, m_ignore}
+};
+
+struct Message svsmode_msgtab = {
+  "SVSMODE", 0, 0, 3, 0, MFLG_SLOW, 0,
+  {m_ignore, m_ignore, ms_svsmode, m_ignore}
+};
+
+/* Thats the msgtab finished */
+
+#ifndef STATIC_MODULES
+/* Here we tell it what to do when the module is loaded */
+void
+_modinit(void)
+{
+  /* This will add the commands in test_msgtab (which is above) */
+  mod_add_cmd(&svshost_msgtab);
+  mod_add_cmd(&svsnick_msgtab);
+  mod_add_cmd(&svsid_msgtab);
+  mod_add_cmd(&svsmode_msgtab);
+}
+
+/* here we tell it what to do when the module is unloaded */
+void
+_moddeinit(void)
+{
+  /* This will remove the commands in test_msgtab (which is above) */
+  mod_del_cmd(&svshost_msgtab);
+  mod_del_cmd(&svsnick_msgtab);
+  mod_del_cmd(&svsid_msgtab);
+  mod_del_cmd(&svsmode_msgtab);
+}
+
+/* When we last modified the file (shown in /modlist), this is usually:
+ */
+const char *_version = "$Revision: 1.91 $";
+#endif
+
+/*
+ * ms_svshost
+ *	Changes the Targets Virtual Hostname, and also sets +x if its not set already on the target
+ *      parv[0] = sender prefix
+ *      parv[1] = target
+ *      parv[2] = new hostname
+ */
+static void ms_svshost(struct Client *client_p, struct Client *source_p,
+                   int parc, char *parv[])
+{
+	struct Client *target_p;
+	
+	target_p = find_person(parv[1]);
+	/* first find the target that we want to change */
+	if (target_p != NULL) {
+		ilog(L_WARN, "svshost: Found Target %s", target_p->name);
+		
+		if ( IsServer(source_p) || (strcmp(SERVICES, source_p->name) || strcmp(HOSTSERV, source_p->name))) {
+			
+			ilog(L_WARN, "svshost: Setting his own hostname %s (from %s)", target_p->name, client_p->name);
+
+			SetHidden(target_p);		
+			strncpy(target_p->vhost, parv[2], HOSTLEN);
+		
+			/* send it to the rest of the net */
+			sendto_server(client_p, target_p, NULL, 0, 0, LL_ICLIENT, ":%s SVSHOST %s :%s", source_p->name, target_p->name, target_p->vhost);
+	
+			return;
+		
+		} else {
+			sendto_realops_flags(FLAGS_ALL, L_ALL, "Non Services %s is attempting to use svshost on %s", source_p->name, target_p->name);
+			sendto_realops_flags(FLAGS_ALL, L_ALL, "Host: %s.", source_p->host);
+			return;
+		}
+	} else {
+		ilog(L_WARN, "svshost: Couldn't find target %s", parv[1]);
+		/* we couldn't find the target. Just exit */
+		return;
+	}
+}    
+	  
+/*
+ * ms_svsnick
+ *	Changes the targets nickname
+ * 	parv[0] = sender prefix
+ *	parv[1] = target 
+ *	parv[2] = new nickname
+ *	parv[3] = ts
+ *
+ */
+static void ms_svsnick(struct Client *client_p, struct Client *source_p,
+		    int parc, char *parv[])
+{
+	struct Client *target_p;
+
+
+	target_p = find_person(parv[1]);
+	if (target_p == NULL) {
+		ilog(L_WARN, "SVSNICK from %s was invalid. Can't find the client", parv[1]);
+		return;
+	}
+	if (!IsClient(target_p)) 
+		return;
+	/*if (!(strcmp(SERVICES, source_p->name) == 0)) {
+		sendto_realops_flags(FLAGS_ALL, L_ALL, "Non Services %s is attempting to use svsnick on %s", source_p->name, target_p->name);
+		return;
+	}*/
+	/* first find the target that we want to change */
+	if (MyClient(target_p)) {
+		if (!clean_nick_name(parv[2]) || !strcmp(target_p->name, parv[2])) {
+			ilog(L_WARN, "svsnick: invalid nickname");
+			return;
+		}
+		target_p->tsinfo = parv[4] ? atol(parv[3]) : CurrentTime;
+		sendto_common_channels_local(target_p, ":%s!%s@%s NICK :%s", target_p->name, target_p->username, target_p->vhost, parv[2]);
+		/* send it to the other servers */	
+		if (target_p->user) {
+			add_history(target_p, 1);
+			sendto_server(NULL, target_p, NULL, 0, 0, LL_ICLIENT, ":%s NICK %s :%lu", target_p->name, parv[2], target_p->tsinfo);
+		}	
+		if (target_p->name[0])
+			del_from_client_hash_table(target_p->name, target_p);
+	
+		strcpy(target_p->name, parv[2]);
+		add_to_client_hash_table(target_p->name, target_p);
+
+		/* del all the accept entries for this nick */
+		del_all_accepts(target_p);
+	} else {
+		/* just relay the svsnick to a server that has this client */
+		sendto_one(target_p, ":%s SVSNICK %s %s :%lu", source_p->name, target_p->name, parv[2], atol(parv[3]));
+		
+	}
+	return;
+
+}
+
+
+/* clean_nick_name()
+ *
+ * input	- nickname
+ * output	- none
+ * side effects - walks through the nickname, returning 0 if erroneous
+ */
+static int clean_nick_name(char *nick)
+{
+  assert(nick);
+  if(nick == NULL)
+    return 0;
+
+  /* nicks cant start with a digit or - */
+  if (*nick == '-' || IsDigit(*nick))
+    return 0;
+
+  for(; *nick; nick++)
+  {
+    if(!IsNickChar(*nick))
+      return 0;
+  }
+
+  return 1;
+}
+
+
+/*
+ * ms_svsid
+ *	Sets/Changes the Services ID for a particular Nickname
+ * 	parv[0] = sender prefix
+ *	parv[1] = target 
+ *	parv[2] = newsvsid
+ *
+ */
+static void ms_svsid(struct Client *client_p, struct Client *source_p,
+		    int parc, char *parv[])
+{
+	struct Client *target_p;
+
+
+	target_p = find_person(parv[1]);
+	if (target_p == NULL) {
+		ilog(L_WARN, "SVSNICK from %s was invalid. Can't find the client", parv[1]);
+		return;
+	}
+	if (!IsClient(target_p)) 
+		return;
+	/*if (!(strcmp(SERVICES, source_p->name) == 0)) {
+		sendto_realops_flags(FLAGS_ALL, L_ALL, "Non Services %s is attempting to use svsid on %s", source_p->name, target_p->name);
+		return;
+	}*/
+	/* set the new ID */
+	target_p->svsid = atol(parv[2]);
+
+	/* and now send it to the rest of the network */
+	sendto_server(client_p, target_p, NULL, 0, 0, LL_ICLIENT, ":%s SVSID %s %lu", source_p->name, target_p->name, target_p->svsid);
+
+	return;
+
+}
+
+static void ms_svsmode(struct Client *client_p, struct Client *source_p,
+                      int parc, char *parv[])
+{
+  struct Client *target_p;
+  if (target_p = find_server(SERVICES)) {
+    user_mode(client_p, source_p, parc, parv);
+  } else if (IsAdmin(client_p)) {
+    sendto_realops_flags(FLAGS_ALL, L_ALL, "%s used SVSMODE on %s", client_p->name, parv[1]);
+    user_mode(client_p, source_p, parc, parv);
+  }
+}
